<div id="body" class="container-fluid">
  <div class="row mx-n5">
    <div class="col">
      <h6 class="mb-1">MDS Design</h6>
      <div class="form-row col-24">
        <div class="form-group form-group-sm row col-12 col-lg-8">
          <label class="col-form-label col-12 col-lg-8">Engagements for:</label>
          <div class="col-12 col-lg-16 pl-0 pl-lg-1">
            <dx-select-box [items]="availableUsers" [value]=0
                           displayExpr="fullNme" valueExpr="userId"
                           [searchEnabled]="true" [searchExpr]="['fullNme']" searchMode="startswith"
                           (onValueChanged)="getUser($event.value)"></dx-select-box>
          </div>
        </div>
        <div class="form-group form-group-sm row col-12 col-lg-6">
          <label class="col-form-label col-12 col-lg-8">Status:</label>
          <div class="col-12 col-lg-16 pl-0 pl-lg-1">
            <dx-select-box [items]="viewOptions" [value]=0
                           displayExpr="stusDes" valueExpr="stusId"
                           [searchEnabled]="true" [searchExpr]="['stusDes']" searchMode="startswith"
                           (onValueChanged)="getStatus($event.value)"></dx-select-box>
          </div>
        </div>
        <div class="form-group form-group-sm col-12 col-md-4 col-lg-3">
          <button type="button" class="btn btn-sm btn-primary btn-block" (click)="btnViewSearch()">
            Search
          </button>
        </div>
      </div>

      <dx-data-grid #grid id="grid" keyExpr="sdeOpportunityID" [dataSource]="viewEngagementsList" [wordWrapEnabled]="true"
                    [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true"
                    (onRowDblClick)="selectionChangedHandler(grid.selectedRowKeys)"
                    (onToolbarPreparing)="onToolbarPreparing($event)"
                    (onExporting)="onExporting($event)">
        <dxo-sorting mode="multiple"></dxo-sorting>
        <dxo-paging [pageSize]="50"></dxo-paging>
        <dxo-selection mode="single"></dxo-selection>
        <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
        <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
        <dxi-column dataField="sdeOpportunityID" caption="ID" dataType="string" cellTemplate="linkIdTemplate"></dxi-column>
        <dxi-column dataField="displayDateTime" caption="DateTime" dataType="datetime"></dxi-column>
        <dxi-column dataField="companyName" caption="Engagement" dataType="string"></dxi-column>
        <dxi-column dataField="contactName" caption="Contact" dataType="string"></dxi-column>
        <dxi-column dataField="statusDesc" caption="Status" dataType="string"></dxi-column>
        <dxi-column dataField="assignedTo" caption="Assigned To" dataType="string"></dxi-column>
        <dxi-column dataField="createdByFullName" caption="Requester" dataType="string"></dxi-column>
        <div *dxTemplate="let data of 'exportTemplate'">
          <button type="button" class="btn btn-sm btn-primary"
                  (click)="grid.instance.exportToExcel(false)">
            Export to Excel
          </button>
        </div>
        <div *dxTemplate="let row of 'linkIdTemplate'">
          <a class="hyperlink" (click)="selectionChangedHandler(row.data.sdeOpportunityID)">{{ row.value }}</a>
        </div>
      </dx-data-grid>
    </div>
  </div>
</div>
